#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdlib.h>

#define PROG "ascii2ams"
char eof='\032';
char eol[2] ="\r\n";

void usage()
{
	fprintf(stderr,"Author:sid@cpcscene.com\n");
	fprintf(stderr,"Convert Unix ascii file in Amsdos ascii file : \nUSAGE: %s <Option> <UNIX FILE> <OUTPUT(optionnal)>\n\n",PROG);
	fprintf(stderr,"Option : \n\t -a convert unix ascii to amsdos\n\t -u convert amsdos ascii to unix\n\n");
	exit(0);
}
void nix2ams(char* in,FILE* out)
{
	char buff[1024];
	FILE* file;
	int i;
	if ((file=fopen(in,"r"))==NULL) 
	{ perror("FILE ERROR\n"); exit(0);}
	
	while (!feof(file))
	{
		fgets(buff,1024,file);
		for (i=0;i<strlen(buff);i++)
		{
			if (buff[i] == '\n') fprintf(out,"%s",eol);
			else fprintf(out,"%c",buff[i]);
		}
	}
	fprintf(out,"%c",eof);
	fclose(file);
}	
void ams2nix(char* in,FILE* out)
{
	char buff[1024];
	FILE* file;
	int i;
	if ((file=fopen(in,"r"))==NULL) 
	{ perror("FILE ERROR\n"); exit(0);}
	
	while (!feof(file))
	{
		fgets(buff,1024,file);
		for (i=0;i<strlen(buff)+1;i++)
		{
			if (buff[i] == '\r') fprintf(out,"\n");
			else if(buff[i] == '\n');
			else if(buff[i] == '\032');
			else if(buff[i] == '\0');
			else fprintf(out,"%c",buff[i]);
		}
	}
	fclose(file);
}	
int main (int argc,char **argv)
{
	char *in;
	char *output;
	FILE * out;

	if (argc < 3 | argc > 4) usage();

	if ( (in=(char*)malloc(strlen(argv[2])+1*sizeof(char))) == NULL)
	{ perror("MEMORY ERROR\n"); exit(0); }
	strcpy(in,argv[2]);

	if (argc == 4) 
	{
		if ( (output=(char*)malloc(strlen(argv[2])+1*sizeof(char))) == NULL)
		{ perror("MEMORY ERROR\n"); exit(0); }
		strcpy(output,argv[3]);
		if ((out=fopen(output,"w"))==NULL)
		{ perror("FILE ERROR\n"); exit(0);}
		if (strcmp(argv[1],"-u")) nix2ams(in,out);
		else if (strcmp(argv[1],"-a")) ams2nix(in,out);
		else { fprintf(stderr,"BAD OPTIONS\n"); fclose(out); exit(0); }
		fclose(out);
	}
	else if (strcmp(argv[1],"-u")) nix2ams(in,stdout);
	else if (strcmp(argv[1],"-a")) ams2nix(in,stdout);
	else { fprintf(stderr,"BAD OPTIONS\n");  exit(0); }
	
	
return 1;
}

